require 'sketchup'

UI.menu("Plugins").add_item("Label Verts") { JF::ordered_vertices }

module JF; end

def JF::ordered_vertices
  model = Sketchup.active_model
  @selection = model.selection

  edges = @selection.select{|e| e.typename == "Edge"}
  #@allverts = edges.collect{|e| e.vertices}.flatten.uniq
  verts = []
  edge0 = @selection[0]
  verts << edge0.start << edge0.end
  get_left verts
  get_right verts

  verts.each_with_index do |v, i|
    model.entities.add_text( i.to_s, v.position )
  end
  # verts is also in order from one end to the next
  verts
end

def JF::get_left(verts)
  edges = verts[0].edges
  return if edges.length != 2
  nverts = edges.collect {|e| e.vertices}
  nverts.flatten!
  nverts.uniq!
  v = nverts - verts
  if v.length > 0 # and @allverts.include? v[0]
    verts.unshift v[0]
    #@selection.add edges if angleBetweenEdges(edges) < 89
    get_left verts
  end
end

def JF::get_right(verts)
  edges = verts[-1].edges
  return if edges.length != 2
  nverts = edges.collect {|e| e.vertices}
  nverts.flatten!
  nverts.uniq!
  v = nverts - verts
  if v.length > 0 # and @allverts.include? v[0]
    #@selection.add edges if angleBetweenEdges(edges) < 89 
    verts.push v[0]
    get_right verts
  end
end

